;;; ElipsTAG.lsp
;;;
;;; Boilerplate:
;;;
;;; This is a program to draw an elliptical and expandable balloon containing
;;; an identifier up to twelve caracters long. 
;;;
;;;
;;; This thing is mine but I will not be held responsible for it's 
;;; misbehavior if there is.
;;;
;;;
;;; Yvan Paquet  
;;; Tel: 514-641-2913
;;; Compuserve ID: 76460,774

;;; Error traps
(defun tagerr (msg)
 (if(member msg '("console break" "Function cancelled" "cancel"))
    (princ "\n*User ")
   (princ (strcat "\nError: " msg))
  );if
 (TAGreset)
 (princ)
 );defun

(defun tcfger (cfmsg)
 (if(member cfmsg '("console break" "Function cancelled" "cancel"))
    (princ "\n*User ")
   (princ (strcat "\nError: " cfmsg))
  );if
 (tcfgrst)
 (princ)
 );defun

;;; Reset functions
(defun tcfgrst()
 (setq *error* def_err
       cflist nil)
 );defun

(defun TAGreset()
 (setvar "clayer" cla)
 (setvar "osmode" osm)
 (setvar "orthomode" ort)
 (setvar "snapmode" sna)
 (setvar "blipmode" blip)
 (setvar "cmdecho" eco)
 (setvar "textsize" dfht)
 (setvar "textstyle" dfsty)
 (setq *error* def_err)
 (command "undo" "e")
 );defun

;;; Main function
(defun ElipsTAG( / fuz cla osm ort sna blip eco asz txtht shift ofil tmp lock
                dfsty txsty ntypa ntypt xth lastr Tkwd bxlstr bxrstr def_err
                lastr colstr col gscl ascl rad rad1 dfht txtht var txptx
                txpty promp balstr hrl vrl bx hrl vrl apnt cflist def_err
                1stpk apntx apnty dzro id pxpt pxptx pxpty pxptz fla lanam
                ntcol drg vlst ervlst Tkwd fnam ptmp tcenpt lcenpt bxl
                bxr p1 p2 p3 p4 bangr 2bangl bang angp1 angp2 angp3 angp4
                lang lncr sncr lrad srad p11 p12 p13 p14 p15 p16 p17
                p21 p22 p23 p24 p25 p31 p32 p33 p34 p35 p36 p37 p41 p42 p43
                p44 p45 pcut apnt1 apnt2 drg pt2 shift tstr OK ptlst)
 (setq fuz(* 0.001(getvar "viewsize"))
       cla(getvar "clayer")
       osm(getvar "osmode")
       ort(getvar "orthomode")
       sna(getvar "snapmode")
       blip(getvar "blipmode")
       eco(getvar "cmdecho")
       dfht(getvar "textsize")
       dfsty (getvar "textstyle")
       Tkwd T
       fnam "utools.cfg"
       def_err *error*
       *error* tagerr
  );setq
 (graphscr)
 (setvar "osmode" 0)
 (setvar "orthomode" 0)
 (setvar "snapmode" 0)
 (setvar "blipmode" 0)
 (setvar "cmdecho" 0)
 (if(not def$tr)(setq def$tr ""))
 (command "undo" "g")
 (if(findfile fnam)
      (progn(setq ofil(open(findfile fnam)"r")
                  tmp T
             );setq
            (while tmp(setq tmp(read-line ofil))
                      (if tmp(setq cflist(cons(substr tmp 3)cflist)))
             );while
            (close ofil)
            (setq cflist(reverse cflist))
       );progn
      (setq cflist(list "Shifted" "UTOOL$" "5" "No" "1.0" "1.0" dfsty))
  );if
 (if(not(setq txsty(cdr(assoc 2(tblsearch "style"(nth 6 cflist))))))
     (setq txsty dfsty))
 (setq shift(nth 0 cflist)
       lastr(nth 1 cflist)
       colstr(nth 2 cflist)
       lock(nth 3 cflist)
       gscl(atof(nth 4 cflist))
       ascl(atof(nth 5 cflist))
       col(atoi colstr)
       fla(cdr(assoc 70(tblsearch "layer" lastr)))
       lanam(cdr(assoc 2(tblsearch "layer" lastr)))
       col(cdr(assoc 62(tblsearch "layer" lastr)))
       rad 0
       rad1(* pi 1.5)
       asz(*(getvar "dimasz")(getvar "dimscale")ascl)
       txtht(* dfht 1.3 gscl)
       var 0
  );setq
 (cond
  ((and(not lanam)(= lock "No"))
    (command "layer" "m" lastr "c" colstr "" "")
   );cond1
  ((and(not lanam)(= lock "Yes"))
    (command "layer" "m" lastr "c" colstr lastr "lo" lastr "")
   );cond1
  ((and lanam(/= fla 64))
    (command "layer" "t" lastr "on" lastr "c" colstr lastr "s" lastr "")
   );cond2
  ((and lanam(= fla 64)(= lock "Yes"))
    (command "layer" "on" lastr "c" colstr lastr "lo" lastr "s" lastr "")
   );cond3
  ((and lanam(= fla 64))
    (command "layer" "on" lastr "c" colstr lastr "u" lastr "s" lastr "")
   );cond3
  );cond ovrall
 (while Tkwd
 (while(or(not balstr)(=(strlen balstr)0)(>(strlen balstr)12))
  (if(or(= shift "All")(= shift "Typed"))
      (setq promp(strcase def$tr))
   );if
  (setq promp(strcat "\nEnter Balloon Text <" def$tr ">: ")
        balstr(getstring T promp)
   );setq
  (if(and(=(strlen balstr)0)(/=(strlen def$tr)0))(setq balstr def$tr))
  (if(=(strlen balstr)0)
       (princ "\nNo null string. Ctrl+C to quit or")
       (setq def$tr balstr)
   );if
  (if(and(>(strlen balstr)0)(<(strlen balstr)13))
       (setq def$tr balstr)
   );if
  (if(or(= shift "All")(= shift "Typed"))
       (setq balstr(strcase balstr)
              def$tr balstr
         );setq
   );if
  (if(>(strlen balstr)12)
      (princ "\nNo string longer than 12 chrs. Ctrl+C to quit or")
   );if
  );while
  (if(or(=(ascii balstr)32)(=(ascii balstr)46))
      (setq hrl(* dfht 0.1 gscl)
             vrl(* dfht 0.65 gscl)
        );setq
       (setq bx(textbox(list(cons 1 balstr)))
             hrl(* 0.125 gscl(caadr bx))
             vrl(* 0.6 gscl(cadadr bx))
        );setq
   );if
 (while(not apnt)
  (graphscr)
  (setq apnt(getpoint "\nEnter arrow point: "))
  (if(not apnt)(princ "\nNo null pick. Ctrl+C to quit or")
      (setq 1stpk T
            apntx(car apnt)
            apnty(cadr apnt)
            apntz(caddr apnt)
       );setq
   );if
  );while
 (prompt "\nPick next Point or Enter to place Text: ")
 (princ)
 (while apnt
  (setq dzro(grread T 5 1)
        id(car dzro)
   );setq
  (if(or(= id 5)
         (= id 3)
       );or
  (setq pxpt(cadr dzro)
        pxptx(caadr dzro)
        pxpty(cadadr dzro)
        pxptz(car(cddadr dzro))
   );setq
   );if
  (cond
   ((or(equal dzro(list 6 0))(equal dzro(list 2 13)))
      (grvecs ervlst)
      (setq drg T
            ervlst nil
       );setq
      (if 1stpk
        (command "solid" apnt1 apnt apnt2 "" ""));if
      (command "line" apnt pcut "")
      (command "arc" "c" lcenpt p1 p2)
      (command "arc" "c" bxl p2 p3)
      (command "arc" "c" tcenpt p3 p4)
      (command "arc" "c" bxr p4 p1)
      (command "text" "s" txsty "mc" pxpt txtht 0 balstr)
      (setq apnt nil
            Tkwd nil)
      (princ)
    );cond 6 0
   ((and(= id 5)(not(equal pxpt ptmp(+ fuz 0.001))))
     (setq ptmp pxpt
           tcenpt(list pxptx(+ pxpty(* hrl 10.0))pxptz)
           lcenpt(list pxptx(- pxpty(* hrl 10.0))pxptz)
           bxl(list(- pxptx(* hrl 3.75))pxpty pxptz)
           bxr(list(+ pxptx(* hrl 3.75))pxpty pxptz)
           p1(polar bxr(angle lcenpt bxr)(* vrl 2))
           p2(polar bxl(angle lcenpt bxl)(* vrl 2))
           p3(polar bxl(angle tcenpt bxl)(* vrl 2))
           p4(polar bxr(angle tcenpt bxr)(* vrl 2))
           bangr(angle lcenpt bxr)
           bangl(angle lcenpt bxl)
           bang(- bangl bangr)
           angp1(angle bxr p1)
           angp2(angle bxl p2)
           angp3(angle bxl p3)
           angp4(angle bxr p4)
           lang(- angp3 angp2)
           lncr(/ bang 8)
           sncr(/ lang 6)
           lrad(distance lcenpt p1)
           srad(distance bxr p1)
           p11(polar lcenpt(+(angle lcenpt p1)lncr)(distance lcenpt p1))
           p12(polar lcenpt(+(angle lcenpt p11)lncr)(distance lcenpt p1))
           p13(polar lcenpt(+(angle lcenpt p12)lncr)(distance lcenpt p1))
           p14(polar lcenpt(+(angle lcenpt p13)lncr)(distance lcenpt p1))
           p15(polar lcenpt(+(angle lcenpt p14)lncr)(distance lcenpt p1))
           p16(polar lcenpt(+(angle lcenpt p15)lncr)(distance lcenpt p1))
           p17(polar lcenpt(+(angle lcenpt p16)lncr)(distance lcenpt p1))
           p21(polar bxl(+(angle bxl p2)sncr)(distance bxl p2))
           p22(polar bxl(+(angle bxl p21)sncr)(distance bxl p2))
           p23(polar bxl(+(angle bxl p22)sncr)(distance bxl p2))
           p24(polar bxl(+(angle bxl p23)sncr)(distance bxl p2))
           p25(polar bxl(+(angle bxl p24)sncr)(distance bxl p2))
           p31(polar tcenpt(+(angle tcenpt p3)lncr)(distance tcenpt p3))
           p32(polar tcenpt(+(angle tcenpt p31)lncr)(distance tcenpt p3))
           p33(polar tcenpt(+(angle tcenpt p32)lncr)(distance tcenpt p3))
           p34(polar tcenpt(+(angle tcenpt p33)lncr)(distance tcenpt p3))
           p35(polar tcenpt(+(angle tcenpt p34)lncr)(distance tcenpt p3))
           p36(polar tcenpt(+(angle tcenpt p35)lncr)(distance tcenpt p3))
           p37(polar tcenpt(+(angle tcenpt p36)lncr)(distance tcenpt p3))
           p41(polar bxr(+(angle bxr p4)sncr)(distance bxr p4))
           p42(polar bxr(+(angle bxr p41)sncr)(distance bxr p4))
           p43(polar bxr 0.0(distance bxr p4))
           p44(polar bxr sncr(distance bxr p4))
           p45(polar bxr(+(angle bxr p44)sncr)(distance bxr p4))
      );setq
     (setq vlst(list 256 p1 p11 p11 p12 p12 p13 p13 p14 p14 p15 p15 p16 p16 
                         p17 p17 p2 p2 p21 p21 p22 p22 p23 p23 p24 p24 p25 
                         p25 p3 p3 p31 p31 p32 p32 p33 p33 p34 p34 p35 p35 
                         p36 p36 p37 p37 p4 p4 p41 p41 p42 p42 p43 p43 p44 
                         p44 p45 p45 p1))
     (cond
          ((and(<= pxpty apnty)(>(angle lcenpt apnt)angp1)
                (<(angle lcenpt apnt)angp2))
           (setq vlst(append vlst(list apnt(setq pcut(polar lcenpt(angle lcenpt apnt)lrad))))))
          ((and(>(angle bxl apnt)angp2)(<(angle bxl apnt)angp3))
           (setq vlst(append vlst(list apnt(setq pcut(polar bxl(angle bxl apnt)srad))))))
          ((and(>= pxpty apnty)(>(angle tcenpt apnt)angp3)
                (<(angle tcenpt apnt)angp4))
           (setq vlst(append vlst(list apnt(setq pcut(polar tcenpt(angle tcenpt apnt)lrad))))))
          ((or(>(angle bxr apnt)angp4)(<(angle bxr apnt)angp1))
           (setq vlst(append vlst(list apnt(setq pcut(polar bxr(angle bxr apnt)srad))))))
      );cond
     (cond 
          (1stpk
           (setq apnt1(polar apnt(-(angle apnt pcut)0.165)asz)
                 apnt2(polar apnt(+(angle apnt pcut)0.165)asz)
                 vlst(append vlst(list apnt apnt1 apnt1 apnt2 apnt2 apnt)
                      );append
            );setq
           );cond 1stpk
      );cond
     (if(not(equal vlst ervlst fuz))
         (progn
          (grvecs ervlst)
          (setq drg T
                ervlst nil
           );setq
          );progn
      );if
     (if(and vlst drg)
         (progn
          (grvecs vlst)
          (setq drg nil
                ervlst vlst
                vlst nil
           );setq
          );progn
      );if
    );cond id5
   ((= id 3)
      (grvecs ervlst)
      (setq drg T
            ervlst nil
       );setq
      (if 1stpk
        (command "_solid" apnt1 apnt apnt2 "" "")
       );if
       (command "_line" apnt pcut "")
      (setq apnt pcut
            1stpk nil
            ptmp nil
       );setq
    );cond id3
   );cond overall
  );while apnt
  );while tkwd
 (cond
  ((or(= fla 65)(= fla 69))
    (progn(setq kwprp(strcat  "\n Layer >"(strcase lastr)"< was frozen"
                                "\n Keep it frozen? No or <Yes>: "))
          (initget "Yes No")
          (setq lakw(getkword  kwprp))
          (if(or(= lakw "Yes")(not lakw))
              (progn(setvar "clayer" cla)
                    (command "layer" "F" lastr "")
               );progn
           );if
     );progn
   );cond1
  );cond
 (TAGreset)
 (princ)
 );defun

(defun c:TAG()
(ElipsTAG))

(princ "\n*****  ElipsTAG.lsp loaded  *****")
(princ "\n      *** *** C:TAG *** ***")
(princ)
