;;; DESCription.lsp
;;;
;;; Boilerplate:
;;;
;;; This is a program to draw an elliptical and expandable balloon containing
;;; a part number after what the program asks several questions wich can be 
;;; skipped or answred and printed on screen one by one below the balloon and
;;; title, thus completing the DESCription.
;;;
;;; This thing is mine but I will not be held responsible for it's 
;;; misbehavior if there is.
;;;
;;;
;;; Yvan Paquet  
;;; Tel: 514-641-2913
;;; Compuserve ID: 76460,774
;;;
;;;
;;; Error trap
(defun dscerr (msg)
 (if (member msg '("console break" "Function cancelled" "cancel"))
    (princ "\n*User ")
   (princ (strcat "\nError: " msg))
  );if
 (dscreset)
 (princ)
 );defun

;;; Reset function
(defun dscreset ()
 (setvar "clayer" cla)
 (setvar "osmode" osm)
 (setvar "orthomode" ort)
 (setvar "snapmode" sna)
 (setvar "blipmode" blip)
 (setvar "cmdecho" eco)
 (setvar "textsize" oht)
 (setvar "textstyle" dfsty)
 (setq *error* acaderr)
 (command "undo" "e")
 );defun


;;; Main function
(defun desc (/ eco osm cla ort sna blip hard matl dfsty dfht Tkwd fnam defstr
               ofil tmp cflist shift lastr colstr lock gscl col fla lanam rad
               rad1 txtht baltxt txpt txptx txpty promp balstr bx bxr und
               bxl hrl vrl ptmp lcenpt tcenpt p1 p2 p3 p4 angp1 angp2 angp3
               angp4 ntypa ntypt xth pt2 destxt inc fixe ok snot free pt3
               destxt2 wstr str1 str2 fixed pt4 lakw prt destr rawstr oht
               txsty)
 (setq eco (getvar "cmdecho")
       cla (getvar "clayer")
       ort (getvar "orthomode")
       sna (getvar "snapmode")
       osm (getvar "osmode")
       blip (getvar "blipmode")
       hard (getvar "users3")
       matl (getvar "users4")
       dfsty (getvar "textstyle")
       Tkwd T
       fnam "utools.cfg"
       acaderr *error*
       *error* dscerr
  );setq
 (setvar "blipmode" 0)
 (setvar "cmdecho" 0)
 (setvar "osmode" 0)
 (setvar "orthomode" 0)
 (setvar "snapmode" 0)
 (graphscr)
 (command "undo" "g")
 (if(not def$tr)(setq def$tr ""))
 (if(findfile fnam)
      (progn(setq ofil(open(findfile fnam)"r")
                  tmp T
             );setq
            (while tmp(setq tmp(read-line ofil))
                      (if tmp(setq cflist(cons(substr tmp 3)cflist)))
             );while
            (close ofil)
            (setq cflist(reverse cflist))
       );progn
      (setq cflist(list "Shifted" "UTOOL$" "5" "No" "1.0" "1.0" dfsty))
  );if
 (if(not(setq txsty(cdr(assoc 2(tblsearch "style"(nth 6 cflist))))))
     (setq txsty dfsty))
 (setq shift(nth 0 cflist)
       lastr(nth 1 cflist)
       colstr(nth 2 cflist)
       lock(nth 3 cflist)
       gscl(atof(nth 4 cflist))
       col(atoi colstr)
       fla(cdr(assoc 70(tblsearch "layer" lastr)))
       lanam(cdr(assoc 2(tblsearch "layer" lastr)))
       rad 0
       rad1(* pi 1.5)
       oht (getvar "textsize")
       dfht (* oht gscl)
       txtht (* dfht 1.5)
       baltxt (* dfht 1.5)
  );setq
 (cond
  ((and(not lanam)(= lock "No"))
    (command "layer" "m" lastr "c" colstr "" "")
   );cond1
  ((and(not lanam)(= lock "Yes"))
    (command "layer" "m" lastr "c" colstr lastr "lo" lastr "")
   );cond1
  ((and lanam(/= fla 64))
    (command "layer" "t" lastr "on" lastr "c" colstr lastr "s" lastr "")
   );cond2
  ((and lanam(= fla 64)(= lock "Yes"))
    (command "layer" "on" lastr "c" colstr lastr "lo" lastr "s" lastr "")
   );cond3
  ((and lanam(= fla 64))
    (command "layer" "on" lastr "c" colstr lastr "u" lastr "s" lastr "")
   );cond3
  );cond ovrall
 (while (not txpt)
         (setq txpt (getpoint "\nPick center of balloon: ")
               txptx (car txpt)
               txpty (cadr txpt)
          );setq
  );while
 (while (or (not balstr)(= (strlen balstr) 0)(> (strlen balstr) 24))
  (setq defstr (getvar "users1"))
  (if (or (= shift "All")(= shift "Typed"))
       (setq promp (strcase defstr))
   );if
  (setq promp (strcat "\nEnter Item Number <" defstr ">: ")
        balstr (getstring T promp)
   );setq
  (if (and (= (strlen balstr) 0)(/= (strlen defstr) 0))(setq balstr defstr))
  (if (= (strlen balstr) 0)
       (princ "\nNo null string. Ctrl+C to quit or")
   );if
  (if (and (> (strlen balstr) 0)(< (strlen balstr) 25))
       (setvar "users1" balstr)
   );if
  (if (> (strlen balstr) 24)
       (princ "\nNo tring longer than 24 chrs. Ctrl+C to quit or")
   );if
  );while
  (if(or(=(ascii balstr)32)(=(ascii balstr)46))
      (setq hrl(* dfht 0.2 gscl)
             vrl(* dfht 0.25 gscl)
        );setq
       (setq bx(textbox(list(cons 1 balstr)))
             hrl(* gscl(caadr bx))
             vrl(* gscl(cadadr bx))
        );setq
   );if
  (setq ptmp pxpt
       tcenpt (list txptx (+ txpty (* hrl 4)))
       lcenpt (list txptx (- txpty (* hrl 4)))
       bxl (list (- txptx hrl) txpty)
       bxr (list (+ txptx hrl) txpty)
       p1 (polar bxr (angle lcenpt bxr)(* vrl 1.1))
       p2 (polar bxl (angle lcenpt bxl)(* vrl 1.1))
       p3 (polar bxl (angle tcenpt bxl)(* vrl 1.1))
       p4 (polar bxr (angle tcenpt bxr)(* vrl 1.1))
       angp1 (angle lcenpt bxr)
       angp2 (angle lcenpt bxl)
       angp3 (angle tcenpt bxl)
       angp4 (angle tcenpt bxr)
       ntypa (cons 0 "ARC")
       ntypt (cons 0 "TEXT")
       lanam (cons 8 lastr)
       xth (list 210 0.0 0.0 1.0)
  );setq
 (command "arc" "c" lcenpt p1 p2)
 (command "arc" "c" bxl p2 p3)
 (command "arc" "c" tcenpt p3 p4)
 (command "arc" "c" bxr p4 p1)
 (if (or (= shift "All")(= shift "Typed"))
     (setq balstr (strcase balstr))
  );if
 (command "text" "s" txsty "mc" txpt baltxt 0 balstr)
 (setq pt2 (polar (polar bxr rad (* dfht 2.5)) rad1 (* txtht 0.75))
       destxt (getstring t "\nEnter Title: ")
  );setq
 (if (or (= shift "All")(= shift "Typed"))
      (setq destxt (strcase destxt))
  );if
 (command "text" "s" txsty pt2 txtht 0 destxt)
 (setq OK T
       destxt nil
       inc (* dfht 1.75)
  );setq 
 (if OK
  (progn (setq promp "\n Enter Cat. No.: "
               fixe "Cat No: "
          );setq
         (prnt)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Enter Description: "
               fixe "Description: "
          );setq
         (prnt)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Enter Qty req'd: "
               fixe "Qty req'd: "
          );setq
         (prnt)
   );progn
  );if
 (if OK
  (progn (if (> (strlen matl) 0)
              (setq promp (strcat "\n Enter Material <"matl"> Type in Yes or your choice: "))
              (setq promp "\n Enter Material: ")
          );if
         (setq fixe "Mat'l: ")
         (prnt)
   );progn
  );if
 (if OK
  (progn (if (> (strlen hard) 0)
              (setq promp (strcat "\n Enter Hardness <"hard"> Type in Yes or your choice: "))
              (setq promp "\n Enter Hardness: ")
          );if
         (setq fixe "Hardness: ")
         (prnt)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Type or Pick Lenght: "
               fixe "Lenght: "
          );setq
         (dstanc)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Type or Pick Diameter: "
               fixe "Diameter: "
          );setq
         (dstanc)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Type or Pick Width: "
               fixe "Width: "
          );setq
         (dstanc)
   );progn
  );if
 (if OK
  (progn (setq promp "\n Type or Pick Thickness: "
               fixe "Thickness: "
          );setq
         (dstanc)
   );progn
  );if
 (if (or OK snot)
  (progn (setq promp "\n Type Special Note: "
               fixe "Note: "
               free T
          );setq
         (prnt)
   );progn
  );if
 (while free
 (setq pt3 (polar pt2 rad1 inc)
       destxt2 (getstring T "\n ENTER< to quit or Type Text: ")
  );setq
 (cond 
  ((= destxt2 "") 
   (setq free nil)
   );cond1
  ((and (> (strlen destxt2) 0)(wcmatch destxt2 "*:*"))
    (progn (setq wstr destxt2
                 pt3 (polar pt2 rad1 inc)
                 str1 ""
            );setq
           (while (wcmatch wstr "*:*")
                   (setq str1 (strcat str1 (substr wstr 1 1))
                         wstr (substr wstr 2)
                         str2 wstr
                    );setq
            );while
           (setq str1 (strcat str1 " "))
           (if (= shift "All")
                (setq str1 (strcase str1))
            );if
           (command "text" "s" txsty "r" pt3 dfht 0 str1)
           (if (= (substr str2 1 1) " ")(setq str2 (substr str2 2)))
           (if (or (= shift "All")(= shift "Typed"))
                (setq str2 (strcase str2))
            );if
           (command "text" "s" txsty pt3 dfht 0 str2)
           (setq pt2 pt3
                 fixed str1
            );setq
     );progn
   );cond2
  ((> (strlen destxt2) 0)
   (progn
     (cond
      (fixed
       (setq pt4 (list (- (car pt3)(caadr (textbox (list (cons 1 fixed)))))(cadr pt3))
             fixed nil
        );setq
       );cond fixed
      (pt4
       (setq pt4 (polar pt4 rad1 inc))
       );cond pt4
      (pt3
       (setq pt4 (polar pt2 rad1 inc))
       );cond pt3
     );cond all 
     (if (or (= shift "All")(= shift "Typed"))
          (setq destxt2 (strcase destxt2))
      );if
     (command "text" "s" txsty pt4 dfht 0 destxt2)
     (setq pt2 pt3)
    );progn
   );cond4
  );cond overall
  );while free
 (cond
  ((or(= fla 65)(= fla 69))
    (progn(setq kwprp(strcat  "\n Layer >"(strcase lastr)"< was frozen"
                                "\n Keep it frozen? No or <Yes>: "))
          (initget "Yes No")
          (setq lakw(getkword  kwprp))
          (if(or(= lakw "Yes")(not lakw))
              (progn(setvar "clayer" cla)
                    (command "layer" "F" lastr "")
               );progn
           );if
     );progn
   );cond1
  );cond
 (dscreset)
 (princ)
 );defun

(defun prnt()
 (setq prt T)
 (while prt
  (setq promp (strcat "\n ENTER< for next, Blank line, eXit or" promp)
        destr (getstring T  promp)
   );setq
  (cond
   ((= destr "")
     (setq prt nil
      );setq
    );cond1
   ((or (= destr "X")
        (= destr "x")
        (= destr "EXIT")
        (= destr "exit")
        (= destr "Exit")
        (= destr "eXit")
     );or
     (setq prt nil
           OK nil
           free nil
      );setq
    );cond2
   ((or (= destr "B")
        (= destr "b")
        (= destr "BLANK")
        (= destr "blank")
        (= destr "Blank")
     );or
     (setq prt nil
           OK nil
           free T
      );setq
    );cond3
   ((and (= fixe "Hardness: ")
         (or (= destr "Y")
             (= destr "y")
             (= destr "YES")
             (= destr "yes")
             (= destr "Yes")
          );or
     );and
          (progn (setq pt3 (polar pt2 rad1 inc)
                  );setq
                 (if (= shift "All")
                      (setq fixe (strcase fixe))
                  );if
                 (command "text" "s" txsty "r" pt3 dfht 0 fixe)
                 (if snot (setq snot nil))
                 (if (or (= shift "All")(= shift "Typed"))
                       (setq destr (strcase hard))
                        (setq destr hard)
                  );if
                 (command "text" "s" txsty pt3 dfht 0 destr)
                 (setvar "users3" destr)
                 (setq pt2 pt3 prt nil fixed fixe)
           );progn
    );cond4
   ((and (= fixe "Mat'l: ")
         (or (= destr "Y")
             (= destr "y")
             (= destr "YES")
             (= destr "yes")
             (= destr "Yes")
          );or
     );and
          (progn (setq pt3 (polar pt2 rad1 inc)
                  );setq
                 (if (= shift "All")
                      (setq fixe (strcase fixe))
                  );if
                 (command "text" "s" txsty "r" pt3 dfht 0 fixe)
                 (if (or (= shift "All")(= shift "Typed"))
                       (setq destr (strcase matl))
                       (setq destr matl)
                  );if
                 (command "text" "s" txsty pt3 dfht 0 destr)
                 (setvar "users4" destr)
                 (setq pt2 pt3 prt nil fixed fixe)
           );progn
    );cond5
   ((> (strlen destr) 0)
     (progn (setq pt3 (polar pt2 rad1 inc))
            (if (= shift "All")
                 (setq fixe (strcase fixe))
             );if
            (command "text" "s" txsty "r" pt3 dfht 0 fixe)
            (if (or (= shift "All")(= shift "Typed"))
                 (setq destr (strcase destr))
             );if
            (command "text" "s" txsty pt3 dfht 0 destr)
            (if (or (= fixe "Hardness: ")
                    (= fixe "HARDNESS: ")
                 );or
                     (setvar "users3" destr)
             );if
            (if (or (= fixe "Mat'l: ")
                    (= fixe "MAT'L: ")
                 );or
                     (setvar "users4" destr)
             );if
            (setq pt2 pt3 prt nil fixed fixe)
      );progn
    );cond6
   );cond overall
  );while prt
 (princ)
 );defun prnt

(defun dstanc()
 (setq prt T)
  (while prt
  (setq rawstr nil
        promp (strcat "\n ENTER< for next, Blank line, eXit or" promp)
   );setq
  (initget 134)
  (setq rawstr (getdist promp))
  (cond
   ((not rawstr)
     (setq destr "")
    );cond1
   ((numberp rawstr)
     (if (= fixe "Diameter: ")
          (setq destr (strcat "%%c" (rtos rawstr)))
          (setq destr (rtos rawstr))
      );if
    );cond2
   ((= (type rawstr) 'STR)
     (setq destr rawstr)
    );cond3
   );cond overall
   (cond
   ((= destr "")
     (setq prt nil
      );setq
    );cond1
   ((or (= destr "X")
        (= destr "x")
        (= destr "EXIT")
        (= destr "exit")
        (= destr "Exit")
        (= destr "eXit")
     );or
     (setq prt nil
           OK nil
           free nil
      );setq
    );cond2
   ((or (= destr "B")
        (= destr "b")
        (= destr "BLANK")
        (= destr "blank")
        (= destr "Blank")
     );or
     (setq prt nil
           OK nil
           free T
      );setq
    );cond3
   ((> (strlen destr) 0)
     (progn (setq pt3 (polar pt2 rad1 inc)
             );setq
            (if (= shift "All")
                 (setq fixe (strcase fixe))
             );if
            (command "text" "s" txsty "r" pt3 dfht 0 fixe)
            (if (or (= fixe "Diameter: ")(= fixe "DIAMETER: "))
                 (setq OK nil
                       snot T
                  );setq
             );if
            (if (or (= shift "All")(= shift "Typed"))
                 (setq destr (strcase destr))
             );if
            (command "text" "s" txsty pt3 dfht 0 destr)
            (setq pt2 pt3 prt nil fixed fixe)
      );progn
    );cond4
   );cond overall
   );while prt
 (princ)
 );defun dstanc

(defun c:desc ()
 (desc))

(princ "\n*****  DESCription.lsp loaded  *****")
(princ "\n       *** *** C:Desc *** ***")
(princ)
