;;; Settol.lsp
;;;
;;; Boilerplate:
;;;
;;; This is a program to set the tolerance variables only. It is quick 
;;; and clean and can be called from within the DIM command.
;;;
;;;
;;; This thing is mine but I will not be held responsible for it's 
;;; misbehavior if there is.
;;;
;;;
;;; Yvan Paquet  
;;; Tel: 514-641-2913
;;; Compuserve ID: 76460,774

;;; Error trap
(defun tolerror (msg)
(if (member msg '("console break" "Function cancelled" "Cancel"))
 (princ "\n*User cancelled*")
 (princ (strcat "\nError: " msg))
 );if
(tolreset)
(princ)
);defun

;;; Reset function
(defun tolreset ()
 (setvar "cmdecho" eco)
 (setq *error* acaderr)
);defun

;;; Main function
(defun settol (/ dcl_tol dtol limit altrn metric tollo tolhi val0 val1 val2 
                 val3 why0 why1 why2 why3 lupr aupr dtolr limr altrr metrr)
 (if (not dcl_tol) (setq dcl_tol (load_dialog "SETTOL")))
 (if dcl_tol
 (progn
  (setq acaderr *error*
        *error* tolerror
        eco (getvar "cmdecho")
        lupr (getvar "luprec")
        aupr (getvar "auprec")
        dtolr (getvar "dimtol")
        limr (getvar "dimlim")
        altrr (getvar "dimalt")
        tollo (getvar "dimtm")
        tolhi (getvar "dimtp")
        val0 aupr
        val1 lupr
        val2 tolhi
        val3 tollo
   );setq
(defun plm ()
(if (= (get_tile "plusminus") "NO")
(progn (set_tile "lim" "NO")
       (set_tile "plusminus" "YES")
       (setq limit nil)
       (setq dtol T))
(progn (set_tile "plusminus" "NO")
       (setq dtol nil))
);if
);defun
(defun limi ()
(if (= (get_tile "lim") "NO")
(progn (set_tile "plusminus" "NO")
       (set_tile "lim" "YES")
       (setq limit T
             dtol nil))
(progn (set_tile "lim" "NO")
       (setq limit nil))
);if
);defun
(defun altr ()
(if (= (get_tile "alt") "NO")
(progn (set_tile "alt" "YES")
       (setq altrn T))
(progn (set_tile "alt" "NO")
       (setq altrn nil))
);if
);defun
(defun axept ()
(if (> val0 8)
    (setvar "auprec" 8)
    (setvar "auprec" val0)
);if
(if (> val1 8)
    (setvar "luprec" 8)
    (setvar "luprec" val1)
);if
(setvar "dimtp" val2)
(setvar "dimtm" val3)
(if dtol
    (progn (setq dtolr 1)(setvar "dimtol" 1))
    (setvar "dimtol" 0)
);if
(if limit
    (progn (setq limr 1)(setvar "dimlim" 1))
    (setvar "dimlim" 0)
);if
(if altrn
    (progn (setq altrr 1)(setvar "dimalt" 1))
    (setvar "dimalt" 0)
);if
);defun axept
     (new_dialog "tolset" dcl_tol)
     (set_tile "aupre_slider" (itoa aupr))
     (if (< (strlen (itoa aupr)) 2)
                (set_tile "aupre" (strcat " " (itoa aupr)))
                (set_tile "aupre" (itoa aupr))
     );if
     (set_tile "lupre_slider" (itoa lupr))
     (if (< (strlen (itoa lupr)) 2)
                (set_tile "lupre" (strcat " " (itoa lupr)))
                (set_tile "lupre" (itoa lupr))
     );if
     (set_tile "hitol_slider" (rtos (* tolhi 10000)))
     (set_tile "hitol" (rtos tolhi 2 4))
     (set_tile "lotol_slider" (rtos (* tollo 10000)))
     (set_tile "lotol" (rtos tollo 2 4))
     (if (= dtolr 1)(progn (plm)(set_tile "plusminus" "YES"))(set_tile "plusminus" "NO"))
     (if (= limr 1)(progn (limi)(set_tile "lim" "YES"))(set_tile "lim" "NO"))
     (if (= altrr 1)(progn (altr)(set_tile "alt" "YES"))(set_tile "alt" "NO"))
(action_tile "aupre_slider" 
             "(setq val0 (atoi $value)
                    why0 $reason)
              (aupslid_upd)")
(action_tile "aupre" 
             "(setq val0 (atoi $value)
                    why0 $reason)
              (aupbox_action)") 
(defun aupslid_upd ()
       (if (or (= why0 3) (= why0 1))
           (if (< (strlen (itoa val0)) 2)
                (set_tile "aupre" (strcat " " (itoa val0)))
                (set_tile "aupre" (itoa val0))
           );if
       );if
);defun
(defun aupbox_action ()
       (if (or (= why0 2) (= why0 1))
          (set_tile "aupre_slider" (itoa val0))))

(action_tile "lupre_slider" 
             "(setq val1 (atoi $value)
                    why1 $reason)
              (lupslid_upd)")
(action_tile "lupre" 
             "(setq val1 (atoi $value)
                    why1 $reason)
              (lupbox_action)") 
(defun lupslid_upd ()
       (if (or (= why1 3) (= why1 1))
           (if (< (strlen (itoa val1)) 2)
                (set_tile "lupre" (strcat " " (itoa val1)))
                (set_tile "lupre" (itoa val1))
           );if
       );if
);defun
(defun lupbox_action ()
       (if (or (= why1 2) (= why1 1))
          (set_tile "lupre_slider" (itoa val1))))
(action_tile "hitol_slider" 
             "(setq val2 (/ (distof $value) 10000)
                    why2 $reason)
              (hitslid_upd)")
(action_tile "hitol" 
             "(setq val2 (distof $value)
                    why2 $reason)
              (hibox_action)") 
(defun hitslid_upd ()
       (if (or (= why2 3) (= why2 1))
          (set_tile "hitol" (rtos val2 2 4))))
(defun hibox_action ()
       (if (or (= why2 2) (= why2 1))
          (set_tile "hitol_slider" (rtos (* val2 10000) 2 4))))
(action_tile "lotol_slider" 
             "(setq val3 (/ (distof $value) 10000)
                    why3 $reason)
              (lotslid_upd)")
(action_tile "lotol" 
             "(setq val3 (distof $value)
                    why3 $reason)
              (lobox_action)") 
(defun lotslid_upd ()
       (if (or (= why3 3) (= why3 1))
          (set_tile "lotol" (rtos val3 2 4))))
(defun lobox_action ()
       (if (or (= why3 2) (= why3 1))
          (set_tile "lotol_slider" (rtos (* val3 10000) 2 4))))
     (action_tile "plusminusb" "(plm)")
     (action_tile "limb" "(limi)")
     (action_tile "altb" "(altr)")
     (action_tile "accept" "(done_dialog)(axept)(tolreset)(unload_dialog dcl_tol)")
     (action_tile "cancel" "(done_dialog)(tolreset)(unload_dialog dcl_tol)")
     (mode_tile "accept" 2)
     (start_dialog)
);progn
);if dcl_tol
(princ)
);defun

(defun C:tol ()
(settol)
);defun

(princ "\n***  Settol Loaded  ***")
(princ "\n   Command name: TOL")
(princ)
